/*
  checking object IN/OUT
*/

#include "rt.h"






int inout( FV *p, int i )
{
int j ;
  
  j = 0;
  
  j = inout_check(j,i);
  switch( (pr[j]).link )
  {
    case 1:
      return( inout_or(p,i,&j) );
    case 2:
      return( inout_and(p,i,&j) );
    case 3:
      return( inout_range(p,i,&j) );
  }
}


int inout_check(int j,int i)
{
int temp,temp1,temp2;
PRIM *pp ;

  for ( temp=j;temp<i;temp++)
  {
    pp = &(pr[temp]) ;
    if ( pp->link == 2 || pp->link == 3 )
    {
    
      temp1 = temp+1;
      temp2 = 0;
      while(1){
        pp = &(pr[temp1]) ;
        switch( pp->link ){
          case -2:
          case -3:
            if( temp2 == 0 ) {
              if ( temp1>i ) 
                return( temp );
              else
                return( inout_check(temp1+1,i) );
            } else {
              temp2--;
            }
            break;
          case 2:
          case 3:
            temp2++;
            break;
        }
        temp1++;
      }
    
    
    }
  }
  return(j);

}


int inout_or( FV *p, int i, int *j)
{
  /* register int j ; */
  PRIM *pp ;
  float *a,x,y,z ;
  float d,e0,e1,e2,e3,e4,e5 ;
  FV vec_tmp ;
  int temp1,temp2 ;


#ifdef DEBUG
fprintf( stderr,"i--In-Out check on prim# %d\n", i ) ;
#endif

  (*j)++;
  while (1) {
  
    pp = &(pr[*j]) ;
    
    switch( pp->link ){
      case 1:
        if( inout_or(p,i,j) == 1 ) return(1);
        break;
      case 2:
        if( inout_and(p,i,j) == 1 ) return(1);
        break;
      case 3:
        if( inout_range(p,i,j) == 1) return(1);
        break;
      case -1:
        (*j)++;
        return(0);
      case -2:
      case -3:
        err("(inout_or) ORubNAND,RANGEŏIĂ܂");
      case 0:
        vec_tmp = *p;
        trans_it(&vec_tmp,pp->mtx1);
        x = vec_tmp.x ; y = vec_tmp.y ; z = vec_tmp.z ;
/*
#ifdef DEBUG
fprintf( stderr, "Cross Point = (%f,%f,%f)\n",x,y,z ) ;
#endif
*/
        e0 = x*x ; e1 = y*y ; e2 = z*z ;
        e3 = x*y ; e4 = y*z ; e5 = x*z ;
        
        if( *j != i ) {
          a = pp->a ;
          switch( pp->ptyp ) {
            case 1:
              d = a[6] * x + a[7] * y + a[8] * z + a[9] ;
              break ;
            case 2:
              d = e0 + e1 + e2 + a[6] * x + a[7] * y + a[8] * z + a[9] ;
              break ;
            case 3:
            case 7:
            case 8:
              d = a[0]*e0 + a[1]*e1 + a[2]*e2 + a[6]*x + a[7]*y + a[8]*z + a[9];              
              
              break ;
            default:
              d = a[0]*e0 + a[1]*e1 + a[2]*e2 +
                  a[3]*e3 + a[4]*e4 + a[5]*e5 +
                  a[6]*x + a[7]*y + a[8]*z + a[9] ;
          }
#ifdef DEBUG
fprintf( stderr,"i-- check with#%d, d=%f,sgn=%d\n",j,d,pr[j].sgn ) ;
#endif
          if( (fsign(d) ^ pp->sgn) != 0 ) {
            temp1 = (*j)+1;
            temp2 = 0;
            while(1){
              pp = &(pr[temp1]) ;
              switch( pp->link ){
                case -1:
                  if( temp2 == 0 ) {
                    *j=temp1+1;
                    return(1);
                  } else {
                    temp2--;
                  }
                  break;
                case 1:
                  temp2++;
                  break;
              }
              temp1++;
            }
          }
        } else {
          temp1 = (*j)+1;
          temp2 = 0;
          while(1){
            pp = &(pr[temp1]) ;
            switch( pp->link ){
              case -1:
                if( temp2 == 0 ) {
                  *j=temp1+1;
                  return(1);
                } else {
                  temp2--;
                }
                break;
              case 1:
                temp2++;
                break;
            }
            temp1++;
          }
        }
        (*j)++;
    } ;
  }
}






int inout_and( FV *p, int i ,int *j)
{
  /*register int j ;*/
  PRIM *pp ;
  float *a,x,y,z ;
  float d,e0,e1,e2,e3,e4,e5 ;
  FV vec_tmp;
  int temp1,temp2;



#ifdef DEBUG
fprintf( stderr,"i--In-Out check on prim# %d\n", i ) ;
#endif

  (*j)++;
  while (1) {
  
    pp = &(pr[*j]) ;
    
    switch( pp->link ){
      case 1:
        if( inout_or(p,i,j) == 0 ) return(0);
        break;
      case 2:
        if( inout_and(p,i,j) == 0 ) return(0);
        break;
      case 3:
        if( inout_range(p,i,j) == 0) return(0);
        break;
      case -2:
        (*j)++;
        return(1);
      case -1:
      case -3:
        err("(inout_and) ANDubNOR,RANGEIĂ܂");
      case 0:
        vec_tmp = *p;
        trans_it(&vec_tmp,pp->mtx1);
        x = vec_tmp.x ; y = vec_tmp.y ; z = vec_tmp.z ;
/*
#ifdef DEBUG
fprintf( stderr, "Cross Point = (%f,%f,%f)\n",x,y,z ) ;
#endif
*/
        e0 = x*x ; e1 = y*y ; e2 = z*z ;
        e3 = x*y ; e4 = y*z ; e5 = x*z ;
        
        if( *j != i ) {
          a = pp->a ;
          switch( pp->ptyp ) {
            case 1:
              d = a[6] * x + a[7] * y + a[8] * z + a[9] ;
              break ;
            case 2:
              d = e0 + e1 + e2 + a[6] * x + a[7] * y + a[8] * z + a[9] ;
              break ;
            case 3:
            case 7:
            case 8:
              d = a[0]*e0 + a[1]*e1 + a[2]*e2 + a[6]*x + a[7]*y + a[8]*z + a[9];              
              
              break ;
            default:
              d = a[0]*e0 + a[1]*e1 + a[2]*e2 +
                  a[3]*e3 + a[4]*e4 + a[5]*e5 +
                  a[6]*x + a[7]*y + a[8]*z + a[9] ;
          }
#ifdef DEBUG
fprintf( stderr,"i-- check with#%d, d=%f,sgn=%d\n",j,d,pr[j].sgn ) ;
#endif
          if( (fsign(d) ^ pp->sgn) == 0 ) {
            temp1 = (*j)+1;
            temp2 = 0;
            while(1){
              pp = &(pr[temp1]) ;
              switch( pp->link ){
                case -2:
                  if( temp2 == 0 ) {
                    *j=temp1+1;
                    return(0);
                  } else {
                    temp2--;
                  }
                  break;
                case 2:
                  temp2++;
                  break;
              }
              temp1++;
            }
          }
        }
        (*j)++;
    } ;
  }
}

int inout_range( FV *p, int i, int *j)
{
  /*register int j ;*/
  PRIM *pp ;
  float *a,x,y,z ;
  float d,e0,e1,e2,e3,e4,e5 ;
  FV vec_tmp;
  int temp1,temp2;



#ifdef DEBUG
fprintf( stderr,"i--In-Out check on prim# %d\n", i ) ;
#endif

/*  (*j)++;  */
  pp = &(pr[*j]);
  pp->link = 999;
  
  while (1) {
  
    pp = &(pr[*j]) ;
    
    switch( pp->link ){
      case 1:
        if( inout_or(p,i,j) == 1 ) return(1);
        break;
      case 2:
        if( inout_and(p,i,j) == 1 ) return(1);
        break;
      case 3:
        if( inout_range(p,i,j) == 1) return(1);
        break;
      case -3:
        (*j)++;
        return(0);
      case -2:
      case -1:
        err("(inout_range) RANGEubNAND,ORŏIĂ܂");
        exit(1);
      case 999:
        pp->link=3;
      case 0:
        vec_tmp = *p;
        trans_it(&vec_tmp,pp->mtx1);
        x = vec_tmp.x ; y = vec_tmp.y ; z = vec_tmp.z ;
/*
#ifdef DEBUG
fprintf( stderr, "Cross Point = (%f,%f,%f)\n",x,y,z ) ;
#endif
*/
        e0 = x*x ; e1 = y*y ; e2 = z*z ;
        e3 = x*y ; e4 = y*z ; e5 = x*z ;
        
        if( *j != i ) {
          a = pp->a ;
          switch( pp->ptyp ) {
            case 1:
              d = a[6] * x + a[7] * y + a[8] * z + a[9] ;
              break ;
            case 2:
              d = e0 + e1 + e2 + a[6] * x + a[7] * y + a[8] * z + a[9] ;
              break ;
            case 3:
            case 7:
            case 8:
              d = a[0]*e0 + a[1]*e1 + a[2]*e2 + a[6]*x + a[7]*y + a[8]*z + a[9];              
              
              break ;
            default:
              d = a[0]*e0 + a[1]*e1 + a[2]*e2 +
                  a[3]*e3 + a[4]*e4 + a[5]*e5 +
                  a[6]*x + a[7]*y + a[8]*z + a[9] ;
          }
#ifdef DEBUG
fprintf( stderr,"i-- check with#%d, d=%f,sgn=%d\n",j,d,pr[j].sgn ) ;
#endif
          if( pp->link == 3 ) {
            if( ( fsign(d) ^ 1 ) == 0 ) {
              
              temp1 = (*j)+1;
              temp2 = 0;
              while(1){
                pp = &(pr[temp1]) ;
                switch( pp->link ){
                  case -3:
                    if( temp2 == 0 ) {
                      *j=temp1+1;
                      return(0);
                    } else {
                      temp2--;
                    }
                    break;
                  case 3:
                    temp2++;
                    break;
                }
                temp1++;
              }
            }
          
          } else {
            if( (fsign(d) ^ pp->sgn) != 0 ) {
              temp1 = (*j)+1;
              temp2 = 0;
              while(1){
                pp = &(pr[temp1]) ;
                switch( pp->link ){
                  case -3:
                    if( temp2 == 0 ) {
                      *j=temp1+1;
                      return(1);
                    } else {
                      temp2--;
                    }
                    break;
                  case 3:
                    temp2++;
                    break;
                }
                temp1++;
              }
            }
          }
        } else {
          if( pp->link == 3 ) {
            break;
          } else {
            temp1 = (*j)+1;
            temp2 = 0;
            while(1){
              pp = &(pr[temp1]) ;
              switch( pp->link ){
                case -3:
                  if( temp2 == 0 ) {
                    *j=temp1+1;
                    return(1);
                  } else {
                    temp2--;
                  }
                  break;
                case 3:
                  temp2++;
                  break;
              }
              temp1++;
            }
          }
        }
        (*j)++;
    } ;
  }
}

