/*
check intersect ray and primitive
*/

#include "rt.h"


int cross( FV *eye, FV *vec, float *t, int sf )
{
PRIM *pp ;
int i,tp ;


  tp = -1 ;
  *t = MAX ;
  i=0;
  pp = &(pr[i]) ;
  switch ( (*pp).link ) {
    case  1:
      cross_or( &i, &tp, eye, vec, t, sf );
      pp = &(pr[i-1]) ;
      if ( (*pp).link != -1 ) {
        err("(cross) ̃f[^ubNORŏIĂ܂");
        exit(1);
      }
      break;
    case -1:
    case  2:
    case -2:
    case  3:
    case -3:
    case  0:
    default:
      err("(cross) ̃f[^ubNORŎn܂Ă܂");
  }
  
  
  return(tp);
}



void cross_or( int *i, int *tp, FV *eye, FV *vec, float *t, int sf )
{
PRIM *pp ;
float *fp ;
float t1,t2 ;
FV cp,eye_tmp,vec_tmp ;
float ka,kb,kc,d ;
float ex,ey,ez,vx,vy,vz ;
float v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16,v17,v18 ;



#ifdef DEBUG
fprintf( stderr, "<<<<<<Cross Check>>>>>>>\n" ) ;
#endif
  
  (*i)++;
  
  while(1) { /* for each primitives */
#ifdef DEBUG
fprintf( stderr,"c--Cross check prim# %d\n", i ) ;
#endif
    pp = &(pr[*i]) ;
    
    switch( (*pp).link ){
      case -1:
        (*i)++;
        return;
      case -2:
      case -3:
        err("(cross_or) ORubNAND,RANGEŏIĂ܂");
      case  1:
        cross_or( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -1 ) {
          err("(cross_or) ORubNORŏIĂ܂");
        }
        break;
        
      case  2:
        cross_and( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -2 ) {
          err("(cross_or) ANDubNANDŏIĂ܂");
        }
        break;
        
      case  3:
        cross_range( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -3 ) {
          err("(cross_or) RANGEubNRANGEŏIĂ܂");
        }
        break;
        
      case 0:
        
        
        fp = pp->a ;
        eye_tmp=*eye;
        vec_tmp=*vec;
        trans_it(&eye_tmp,pp->mtx1);
        trans_it2(&vec_tmp,pp->mtx1);
        ex = eye_tmp.x ; ey = eye_tmp.y ; ez = eye_tmp.z ;
        vx = vec_tmp.x ; vy = vec_tmp.y ; vz = vec_tmp.z ;
        v1 = vx*vx; v2 = vy*vy; v3 = vz*vz; v4 = vx*vy; v5 = vy*vz; v6 = vx*vz;
        v7 = vx*ex; v8 = vy*ey; v9 = vz*ez;
        v10 = vx*ey + ex*vy ; v11 = vy*ez + vz*ey ; v12 = vz*ex + vx*ez ;
        v13 = ex*ex; v14 = ey*ey; v15 = ez*ez; v16= ex*ey; v17=ey*ez; v18=ex*ez;        
        
        
        
        
        switch( pp->ptyp ) {
          case 1:
            ka = 0 ;
            kb = fp[6] * vx + fp[7] * vy + fp[8] * vz ;
            kc = fp[6] * ex + fp[7] * ey + fp[8] * ez + fp[9] ;
            break ;
          case 2:
            ka = v1 + v2 + v3 ;
            kb = (v7 + v8 + v9)*2 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;
            kc = v13 + v14 + v15 + fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
            break ;
          case 3:
          case 7:
          case 8:
            ka = fp[0]*v1 + fp[1]*v2 + fp[2]*v3 ;
            kb = (fp[0]*v7+fp[1]*v8+fp[2]*v9)*2 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;
            kc = fp[0]*v13 + fp[1]*v14 + fp[2]*v15 + fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
            break ;
          default:
            ka = fp[0]*v1 + fp[1]*v2 + fp[2]*v3 + fp[3]*v4 + fp[4]*v5 + fp[5]*v6 ;
            kb = ( fp[0]*v7 + fp[1]*v8 + fp[2]*v9 )*2 +  
            fp[3]*v10 + fp[4]*v11 + fp[5]*v12 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;            
            kc = fp[0]*v13 + fp[1]*v14 + fp[2]*v15 + fp[3]*v16 + fp[4]*v17 + fp[5]*v18 	+ fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
        }
/*
#ifdef DEBUG
fprintf( stderr, "equation %f,%f,%f \n",ka,kb,kc ) ;
#endif
*/
        if( fabs(ka) > 0) {/* niji */
          d = kb * kb -  ka * kc *4 ;/* hanbetus shiki */
          if( fsign(d) < 0 )
            goto false ;
          d = sqrt( d ) ; ka = ka * 2 ;
          t1 = (-kb - d )/ka ; t2 = ( -kb + d)/ka ; /* solution */
#ifdef DEBUG
fprintf( stderr, "c--Find 2 solution %f and %f\n", t1,t2 ) ;
#endif
        } else {/* ichji */
          if( fabs(kb) < eps ) goto false ;
          t1 = -kc/kb ;
          t2 = 0 ;
#ifdef DEBUG
fprintf( stderr, "c--Find 1 solution %f \n", t1 ) ;
#endif
        }
        
        if( t1 < eps && t2 < eps ) goto false ;
        
        if( t1 > t2 ) {    /* t2 > t1 */
          d = t1 ; t1 = t2 ; t2 = d ;
        }
        
        if( t1 > eps ) {
          cp.x = eye->x + vec->x * t1 ; cp.y = eye->y + vec->y * t1 ; cp.z = eye->z + vec->z * t1 ;
        if( inout( &cp, *i ) ) {  
            if( t1 < *t ) {
              *t = t1 ;
              *tp = *i ;
            }
            break;
          }
        }
        cp.x = eye->x + vec->x * t2 ; cp.y = eye->y + vec->y * t2 ; cp.z = eye->z + vec->z * t2 ;
        if( inout( &cp, *i ) ) {
          if( t2 < *t ) {
            *t = t2 ;
            *tp = *i ;
          }
          break;
        }
false:;/* no intersect */
#ifdef DEBUG
fprintf( stderr, "c--No Solution\n" ) ;
#endif
    }  /* switch end */
    (*i)++;
  }/* while end */
}



void cross_and( int *i, int *tp, FV *eye, FV *vec, float *t, int sf )
{
  PRIM *pp ;
  float *fp ;
  float t1,t2 ;
  FV cp,eye_tmp,vec_tmp ;
  float ka,kb,kc,d ;
  float ex,ey,ez,vx,vy,vz ;
  float v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16,v17,v18 ;



#ifdef DEBUG
fprintf( stderr, "<<<<<<Cross Check>>>>>>>\n" ) ;
#endif
  
  (*i)++;
  
  while(1) { /* for each primitives */
#ifdef DEBUG
fprintf( stderr,"c--Cross check prim# %d\n", i ) ;
#endif
    pp = &(pr[*i]) ;
    
    switch( (*pp).link ){
      case -2:
        (*i)++;
        return;
      case -1:
      case -3:
        err("(cross_and) ANDubNOR,RANGEŏIĂ܂");
        exit(1);
      case  1:
        cross_or( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -1 ) {
          err("(cross_and) ORubNORŏIĂ܂");
          exit(1);
        }
        break;
        
      case  2:
        cross_and( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -2 ) {
          err("(cross_and) ANDubNANDŏIĂ܂");
          exit(1);
        }
        break;
        
      case  3:
        cross_range( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -3 ) {
          err("(cross_and) RANGEubNRANGEŏIĂ܂");
          exit(1);
        }
        break;
        
      case 0:
        
        
        fp = pp->a ;
        eye_tmp=*eye;
        vec_tmp=*vec;
        trans_it(&eye_tmp,pp->mtx1);
        trans_it2(&vec_tmp,pp->mtx1);
        ex = eye_tmp.x ; ey = eye_tmp.y ; ez = eye_tmp.z ;
        vx = vec_tmp.x ; vy = vec_tmp.y ; vz = vec_tmp.z ;
        v1 = vx*vx; v2 = vy*vy; v3 = vz*vz; v4 = vx*vy; v5 = vy*vz; v6 = vx*vz;
        v7 = vx*ex; v8 = vy*ey; v9 = vz*ez;
        v10 = vx*ey + ex*vy ; v11 = vy*ez + vz*ey ; v12 = vz*ex + vx*ez ;
        v13 = ex*ex; v14 = ey*ey; v15 = ez*ez; v16= ex*ey; v17=ey*ez; v18=ex*ez;
        
        
        
        
        switch( pp->ptyp ) {
          case 1:
            ka = 0 ;
            kb = fp[6] * vx + fp[7] * vy + fp[8] * vz ;
            kc = fp[6] * ex + fp[7] * ey + fp[8] * ez + fp[9] ;
            break ;
          case 2:
            ka = v1 + v2 + v3 ;
            kb = (v7 + v8 + v9)*2 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;
            kc = v13 + v14 + v15 + fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
            break ;
          case 3:
          case 7:
          case 8:
            ka = fp[0]*v1 + fp[1]*v2 + fp[2]*v3 ;
            kb = (fp[0]*v7+fp[1]*v8+fp[2]*v9)*2 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;
            kc = fp[0]*v13 + fp[1]*v14 + fp[2]*v15 + fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
            break ;
          default:
            ka = fp[0]*v1 + fp[1]*v2 + fp[2]*v3 + fp[3]*v4 + fp[4]*v5 + fp[5]*v6 ;
            kb = ( fp[0]*v7 + fp[1]*v8 + fp[2]*v9 )*2 +  
            fp[3]*v10 + fp[4]*v11 + fp[5]*v12 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;
            kc = fp[0]*v13 + fp[1]*v14 + fp[2]*v15 + fp[3]*v16 + fp[4]*v17 + fp[5]*v18 	+ fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
        }
/*
#ifdef DEBUG
fprintf( stderr, "equation %f,%f,%f \n",ka,kb,kc ) ;
#endif
*/
        if( fabs(ka) > 0) {/* niji */
          d = kb * kb -  ka * kc *4 ;/* hanbetus shiki */
          if( fsign(d) < 0 )
            goto false ;
          d = sqrt( d ) ; ka = ka * 2 ;
          t1 = (-kb - d )/ka ; t2 = ( -kb + d)/ka ; /* solution */
#ifdef DEBUG
fprintf( stderr, "c--Find 2 solution %f and %f\n", t1,t2 ) ;
#endif
        } else {/* ichji */
          if( fabs(kb) < eps ) goto false ;
          t1 = -kc/kb ;
          t2 = 0 ;
#ifdef DEBUG
fprintf( stderr, "c--Find 1 solution %f \n", t1 ) ;
#endif
        }
        
        if( t1 < eps && t2 < eps ) goto false ;
        
        if( t1 > t2 ) {    /* t2 > t1 */
          d = t1 ; t1 = t2 ; t2 = d ;
        }
        
        if( t1 > eps ) {
          cp.x = eye->x + vec->x * t1 ; cp.y = eye->y + vec->y * t1 ; cp.z = eye->z + vec->z * t1 ;
        if( inout( &cp, *i ) ) {  
            if( t1 < *t ) {
              *t = t1 ;
              *tp = *i ;
            }
            break;
          }
        }
        cp.x = eye->x + vec->x * t2 ; cp.y = eye->y + vec->y * t2 ; cp.z = eye->z + vec->z * t2 ;
        if( inout( &cp, *i ) ) {
          if( t2 < *t ) {
            *t = t2 ;
            *tp = *i ;
          }
          break;
        }
false:;/* no intersect */
#ifdef DEBUG
fprintf( stderr, "c--No Solution\n" ) ;
#endif
    }  /* switch end */
    (*i)++;
  }/* while end */
}



void cross_range( int *i, int *tp, FV *eye, FV *vec, float *t, int sf )
{
PRIM *pp ;
float *fp ;
float t1,t2 ;
int temp1,temp2;
FV cp,eye_tmp,vec_tmp ;
float ka,kb,kc,d ;
float ex,ey,ez,vx,vy,vz ;
float v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16,v17,v18 ;



#ifdef DEBUG
fprintf( stderr, "<<<<<<Cross Check>>>>>>>\n" ) ;
#endif

  pp = &(pr[*i]) ;
  pp->link = 999;
  
  while(1) { /* for each primitives */
#ifdef DEBUG
fprintf( stderr,"c--Cross check prim# %d\n", i ) ;
#endif
    pp = &(pr[*i]) ;
    
    switch( (*pp).link ) {
      case -3:
        (*i)++;
        return;
      case -2:
      case -1:
        err("(cross_range) RANGEubNAND,ORŏIĂ܂");
      case  1:
        cross_or( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -1 ) {
          err("(cross_range) ORubNORŏIĂ܂");
        }
        break;
        
      case  2:
        cross_and( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -2 ) {
          err("(cross_range) ANDubNANDŏIĂ܂");
        }
        break;
        
      case  3:
        cross_range( i, tp, eye, vec, t, sf );
        (*i)--;
        pp = &(pr[(*i)]) ;
        if ( (*pp).link != -3 ) {
          err("(cross_range) RANGEubNRANGEŏIĂ܂");
        }
        break;
        
      case 999:
        pp->link=3;
      case 0:
        
        
        fp = pp->a ;
        eye_tmp=*eye;
        vec_tmp=*vec;
        trans_it(&eye_tmp,pp->mtx1);
        trans_it2(&vec_tmp,pp->mtx1);
        ex = eye_tmp.x ; ey = eye_tmp.y ; ez = eye_tmp.z ;
        vx = vec_tmp.x ; vy = vec_tmp.y ; vz = vec_tmp.z ;
        v1 = vx*vx; v2 = vy*vy; v3 = vz*vz; v4 = vx*vy; v5 = vy*vz; v6 = vx*vz;
        v7 = vx*ex; v8 = vy*ey; v9 = vz*ez;
        v10 = vx*ey + ex*vy ; v11 = vy*ez + vz*ey ; v12 = vz*ex + vx*ez ;
        v13 = ex*ex; v14 = ey*ey; v15 = ez*ez; v16= ex*ey; v17=ey*ez; v18=ex*ez;
        
        
        
        
        switch( pp->ptyp ) {
          case 1:
            ka = 0 ;
            kb = fp[6] * vx + fp[7] * vy + fp[8] * vz ;
            kc = fp[6] * ex + fp[7] * ey + fp[8] * ez + fp[9] ;
            break ;
          case 2:
            ka = v1 + v2 + v3 ;
            kb = (v7 + v8 + v9)*2 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;
            kc = v13 + v14 + v15 + fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
            break ;
          case 3:
          case 7:
          case 8:
            ka = fp[0]*v1 + fp[1]*v2 + fp[2]*v3 ;
            kb = (fp[0]*v7+fp[1]*v8+fp[2]*v9)*2 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;
            kc = fp[0]*v13 + fp[1]*v14 + fp[2]*v15 + fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
            break ;
          default:
            ka = fp[0]*v1 + fp[1]*v2 + fp[2]*v3 + fp[3]*v4 + fp[4]*v5 + fp[5]*v6 ;
            kb = ( fp[0]*v7 + fp[1]*v8 + fp[2]*v9 )*2 +  
            fp[3]*v10 + fp[4]*v11 + fp[5]*v12 + fp[6]*vx + fp[7]*vy + fp[8]*vz ;
            kc = fp[0]*v13 + fp[1]*v14 + fp[2]*v15 + fp[3]*v16 + fp[4]*v17 + fp[5]*v18 	+ fp[6]*ex + fp[7]*ey + fp[8]*ez + fp[9] ;
        }
/*
#ifdef DEBUG
fprintf( stderr, "equation %f,%f,%f \n",ka,kb,kc ) ;
#endif
*/
        if( fabs(ka) > 0) {/* niji */
          d = kb * kb -  ka * kc *4 ;/* hanbetus shiki */
          if( fsign(d) < 0 )
            goto false ;
          d = sqrt( d ) ; ka = ka * 2 ;
          t1 = (-kb - d )/ka ; t2 = ( -kb + d)/ka ; /* solution */
#ifdef DEBUG
fprintf( stderr, "c--Find 2 solution %f and %f\n", t1,t2 ) ;
#endif
        } else {/* ichji */
          if( fabs(kb) < eps ) goto false ;
          t1 = -kc/kb ;
          t2 = 0 ;
#ifdef DEBUG
fprintf( stderr, "c--Find 1 solution %f \n", t1 ) ;
#endif
        }
        
        if( t1 < eps && t2 < eps ) goto false ;
        
        
        if( pp->link == 3 ) {   /* range primitive */
#ifdef DEBUG
fprintf( stderr, "c--It is Range Primitive\n" ) ;
#endif
          break ;
        }
        
        if( t1 > t2 ) {    /* t2 > t1 */
          d = t1 ; t1 = t2 ; t2 = d ;
        }
        
        if( t1 > eps ) {
          cp.x = eye->x + vec->x * t1 ; cp.y = eye->y + vec->y * t1 ; cp.z = eye->z + vec->z * t1 ;
          if( inout( &cp, *i ) ) {  
            if( t1 < *t ) {
              *t = t1 ;
              *tp = *i ;
            }
            break;
          }
        }
        cp.x = eye->x + vec->x * t2 ; cp.y = eye->y + vec->y * t2 ; cp.z = eye->z + vec->z * t2 ;
        if( inout( &cp, *i ) ) {
          if( t2 < *t ) {
            *t = t2 ;
            *tp = *i ;
          }
          break;
        }
false:/* no intersect */
#ifdef DEBUG
fprintf( stderr, "c--No Solution\n" ) ;
#endif
        if( pp->link == 3 ) {
          temp1 = (*i)+1;
          temp2 = 0;
          while(1){
            pp = &(pr[temp1]) ;
            switch( pp->link ){
              case -3:
                if( temp2 == 0 ) {
                  *i=temp1+1;
                  return;
                } else {
                  temp2--;
                }
                break;
              case 3:
                temp2++;
                break;
            }
            temp1++;
          }
        }
    }/* switch end */
    (*i)++;
  }/* while end */
}

