/*
    Graphics routines for rt
*/

#include <stdio.h>
#include <egb.h>
#include "rt.h"

#define WSIZE 1536

static char work[WSIZE];
static char para[64] ;

void scrninit(void)
{
  EGB_init(work,WSIZE) ;
/*
        EGB_writePage(work,1);OUTP(0xfd9f,0x0f);
        EGB_writePage(work,0);
        EGB_displayPage(work,1,3) ;
  EGB_resolution(work,0,10) ;
  EGB_displayStart(work,1,0,0) ;
  EGB_displayStart(work,2,2,2) ;
  EGB_displayStart(work,3,320,240) ;
*/
  screen(work,0,17);
  
  EGB_paintMode(work,0x22) ;
  EGB_writeMode(work,0) ;
  EGB_pen(work,0) ;
  EGB_penSize(work,1) ;
}


void screen( char *work,int page,int mode )
{
int mx,my,wx,wy ;

  EGB_writePage(work, page ) ;
  EGB_resolution( work, page, mode ) ;
  switch( mode ) {
    
    case 17:             /* 512 * 480 * 32768 */
      mx = my = 1;
      wx = 512 ; wy = 480 ;
      break ;
    defalut: return ;
  }
  EGB_displayStart(work,2,mx,my ) ;
  EGB_displayStart(work,3,wx,wy ) ;
}



void boxfil(int sx,int sy,int ex,int ey,CRGB *col)
{
int x,y;

  EGB_colorIGRB(work,0,col->cb+(col->cr<<8)+(col->cg<<16)) ;
  EGB_colorIGRB(work,2,col->cb+(col->cr<<8)+(col->cg<<16)) ;
  
  for (x=sx;x<=ex;x++){
    for (y=sy;y<=ey;y++){
      WORD(para + 0) = 1;
      WORD(para + 2) = x;
      WORD(para + 4) = y;
      EGB_pset(work,para);
    }
   }  
}

/*
int scrnsave( char *path )
{
	FILE *fp ;

	setTIFFmode( 2, PIXW, PIXH ) ;
	mkIFD() ;
	if( ( fp = fopen( path, "wb" )) == 0 ) return -1 ;
	putIFD( fp ) ;
	svram(fp, work, 0, 0, PIXW, PIXH, 16, 0 ) ;
	fclose( fp ) ;
}
*/
