/*
tracer
*/

#include "rt.h"
#include <string.h>

/*#define DEBUG*/


void rtmain(void)
{
int px,py,pb,i ;
float pv,pu,temp ;
float x,y,z ;
FV tv ;
FRGB pixb0[2049],pixb1[2049],lp_tmp ;
char msg[256];
int status;
char out_file[80],fn[80],ext[80],*tmp;


  lp_tmp.r=1.0;
  lp_tmp.g=1.0;
  lp_tmp.b=1.0;
  
  if (anti!=0) {pb=-1;} else {pb=0;};
  
  
  for (i=0;i<2;i++)
  {
  
    if (  (tmp = strchr(output_filename,'.')) == NULL  ) 
      err("(rtmain) OtBbN̊gq܂");
    tmp++;
    strncpy(ext,tmp,3);
    strncpy(fn,output_filename, strcspn(output_filename,".") );
    fn[strcspn(output_filename,".")]=0;
    strcpy(out_file,output_filename);
    if( rmode==1 )
    {
      if( i==0 )
      {
        ep = lep;
        strcpy(out_file,fn);
        strcat(out_file,"_l.");
        strcat(out_file,ext);
      }
      else
      {
        ep = rep;
        strcpy(out_file,fn);
        strcat(out_file,"_r.");
        strcat(out_file,ext);
      }
    }
    
    record_open(out_file);
    
    for( py = sy + pb*dy; py <= ey; py += dy ) {
      sprintf(msg,"%5d CvZ܂B",py);
      mes(msg);
      raster = py ;
      brpix.b = brpix.r = brpix.g = blpix.b = blpix.r = blpix.g = 0 ;
      bpix.b = bpix.r = bpix.g = 0 ;
      pv = ( (PIXH/2) - py ) * dv ;
      
      
      
      for( px = sx + pb*dx; px <= ex; px += dx ) {
        
        SND_joy_in_1(1,&status);
        if ( (status & 0x30) != 0x30 )
        {
          if(py!=sy+pb*dy) record_write(py);
          record_close();
          mes(" vZ𒆒f܂ ");
          return;
        }
        
        
        
        pu = ( px - (PIXW/2) ) * du ;
#ifdef DEBUG
fprintf( stderr, "px,py= (%d,%d)  pu,pv = (%f,%f)\n", px,py, pu,pv ) ;
#endif
        x = re.x + u.x*pu + v.x*pv ;
        y = re.y + u.y*pu + v.y*pv ;
        z = re.z + u.z*pu + v.z*pv ; /* point on view surface */
#ifdef DEBUG
fprintf( stderr, "point on surface = (%f,%f,%f)\n", x,y,z ) ;
#endif
        
        tv.x = x - ep.x; tv.y = y - ep.y; tv.z = z - ep.z ;
        temp=sqrt((tv.x)*(tv.x) + (tv.y)*(tv.y) + (tv.z)*(tv.z)) ;
        tv.x /= temp;tv.y /=temp; tv.z /= temp ;
        
        lpow = 1 ; trnum = 0 ;
        pix.b = pix.r = pix.g = 0 ;
        trace( &ep, &tv, &pix, lp_tmp ,half, trnum, sky ) ; /* trace */
        pixb1[px+dx]=pix;
        
        if ( (anti!=0) && (px != sx + pb*dx) && (py != sy + pb*dy) ) {
          pix=trace_4pix( (float)(px -dx),(float)(py -dx),(float)px,(float)py,
                          pixb0[px+dx-dx],pixb0[px+dx],
                          pixb1[px+dx-dx],pixb1[px+dx],0,anti_level );
        }
        
        if ( (anti==0 ) || ( (px != sx + pb*dx) && (py != sy + pb*dy) ) )
          record(px,py) ; /* plot 1 pixel */
      }
      
      if( (py!=sy+pb*dy) || (pb==0) ) record_write(py);
      
      
      for( px = sx + pb*dx; px <= ex; px += dx ) {
        pixb0[px+dx]=pixb1[px+dx];
      }
    }
    
    record_close();
    
    if (rmode==0) return;
  }
}

FRGB trace_4pix(float x1,float y1,float x2,float y2,FRGB pix11,FRGB pix12,FRGB pix21,FRGB pix22,int anti_num,float anti_level)
{
FRGB pix0,pix1,pix2,pix3,pix4,pix5,tmp;
float x12,y12,max;

  ++anti_num;
  
  
  pix11.r = (pix11.r > 1)? 1 : pix11.r;
  pix11.g = (pix11.g > 1)? 1 : pix11.g;
  pix11.b = (pix11.b > 1)? 1 : pix11.b;
  pix12.r = (pix12.r > 1)? 1 : pix12.r;
  pix12.g = (pix12.g > 1)? 1 : pix12.g;
  pix12.b = (pix12.b > 1)? 1 : pix12.b;
  pix21.r = (pix21.r > 1)? 1 : pix21.r;
  pix21.g = (pix21.g > 1)? 1 : pix21.g;
  pix21.b = (pix21.b > 1)? 1 : pix21.b;
  pix22.r = (pix22.r > 1)? 1 : pix22.r;
  pix22.g = (pix22.g > 1)? 1 : pix22.g;
  pix22.b = (pix22.b > 1)? 1 : pix22.b;
  
  max=0;
  if (max < abs(pix11.r-pix12.r)) max=abs(pix11.r-pix12.r);
  if (max < abs(pix11.g-pix12.g)) max=abs(pix11.g-pix12.g);
  if (max < abs(pix11.b-pix12.b)) max=abs(pix11.b-pix12.b);
  if (max < abs(pix11.r-pix21.r)) max=abs(pix11.r-pix21.r);
  if (max < abs(pix11.g-pix21.g)) max=abs(pix11.g-pix21.g);
  if (max < abs(pix11.b-pix21.b)) max=abs(pix11.b-pix21.b);
  if (max < abs(pix22.r-pix12.r)) max=abs(pix22.r-pix12.r);
  if (max < abs(pix22.g-pix12.g)) max=abs(pix22.g-pix12.g);
  if (max < abs(pix22.b-pix12.b)) max=abs(pix22.b-pix12.b);
  if (max < abs(pix22.r-pix21.r)) max=abs(pix22.r-pix21.r);
  if (max < abs(pix22.g-pix21.g)) max=abs(pix22.g-pix21.g);
  if (max < abs(pix22.b-pix21.b)) max=abs(pix22.b-pix21.b);
  
  
  
  if (anti_num>=anti || max<anti_level){
    pix0.r=(pix11.r+pix12.r+pix21.r+pix22.r)/4;
    pix0.g=(pix11.g+pix12.g+pix21.g+pix22.g)/4;
    pix0.b=(pix11.b+pix12.b+pix21.b+pix22.b)/4;
    return(pix0);
  }
  else {
    x12=(x1+x2)/2;
    y12=(y1+y2)/2;
    pix1 = trace_xy( x12 , y1  );
    pix2 = trace_xy( x1  , y12 );
    pix3 = trace_xy( x12 , y12 );
    pix4 = trace_xy( x2  , y12 );
    pix5 = trace_xy( x12 , y2  );
    
    
    pix0.r=pix0.g=pix0.b=0;
    
    tmp=trace_4pix(x1,y1,x12,y12,pix11,pix1,pix2,pix3,anti_num,anti_level/2);
    pix0.r+=tmp.r;pix0.g+=tmp.g;pix0.b+=tmp.b;
    tmp=trace_4pix(x12,y1,x2,y12,pix1,pix12,pix3,pix4,anti_num,anti_level/2);
    pix0.r+=tmp.r;pix0.g+=tmp.g;pix0.b+=tmp.b;
    tmp=trace_4pix(x1,y12,x12,y2,pix2,pix3,pix21,pix5,anti_num,anti_level/2);
    pix0.r+=tmp.r;pix0.g+=tmp.g;pix0.b+=tmp.b;
    tmp=trace_4pix(x12,y12,x2,y2,pix3,pix4,pix5,pix22,anti_num,anti_level/2);
    pix0.r+=tmp.r;pix0.g+=tmp.g;pix0.b+=tmp.b;
    
    pix0.r/=4;pix0.g/=4;pix0.b/=4;
    return(pix0);
  }


}

FRGB trace_xy(float px,float py)
{
float pv,pu ;
float x,y,z ;
FV tv ;
FRGB tpix,lp_tmp ;

  lp_tmp.r=1.0;
  lp_tmp.g=1.0;
  lp_tmp.b=1.0;
  
  
  pv = ( (PIXH/2) - py ) * dv ;
  
  pu = ( px - (PIXW/2) ) * du ;
  x = re.x + u.x*pu + v.x*pv ;
  y = re.y + u.y*pu + v.y*pv ;
  z = re.z + u.z*pu + v.z*pv ; /* point on view surface */
  
  tv.x = x - ep.x; tv.y = y - ep.y; tv.z = z - ep.z ;
  temp=sqrt((tv.x)*(tv.x) + (tv.y)*(tv.y) + (tv.z)*(tv.z)) ;
  tv.x /= temp;tv.y /=temp; tv.z /= temp ;
  
  lpow = 1 ; trnum = 0 ;
  tpix.b = tpix.r = tpix.g = 0 ;
  trace( &ep, &tv, &tpix, lp_tmp, half, trnum ,sky ) ; /* trace */
  
  return (tpix);



}


void trace( FV *eye, FV *vec, FRGB *col, FRGB lp, float hf, int trnum, FRGB mistcol )
{
register int i ;
int tprim ;
PRIM *pp ;
float t,tmp,a1,a2,a3,temp ;
FV cp,n,lt,vec_tmp,cp_tmp ;
ELIT *ep ;
PLIT *ptp ;
SLIT *stp ;
float k1,*ap ;
FV *l ,d ;
float cs,ns,nn,r,hf1,hf2 ;
int fl,flg ;
FRGB mistcol2,lp_tmp,lp_tmp2,pref,prefr,sw ;
float p_r,p_g,p_b,pn,phalf ;
SHADE *prm ;
MAP *map_tmp ;
MATRIX pmtx ;





  if( (tprim = cross( eye, vec, &t, 0 )) >= 0 )
  {
#ifdef DEBUG
fprintf(stderr, "t--Ray crossed!! width prim# %d , lp.r = %f , lp.g = %f , lp.b = %f\n",tprim,lp.r,lp.g,lp.b ) ;
#endif
    pp = &(pr[tprim]) ;/* clossed */
    cp.x = eye->x + vec->x * t ;
    cp.y = eye->y + vec->y * t ;
    cp.z = eye->z + vec->z * t ;/* closs point */
    cp_tmp = cp ;
    trans_it(&cp_tmp,pp->mtx1);
    
    /* caluc 'housen vector' */
    ap = pp->a ;
    mtx_copy(pmtx,pp->mtx1) ;
    switch( pp->ptyp) {
      case 1:
        n.x = ap[6] ; n.y = ap[7] ; n.z = ap[8] ;
        break ;
      case 2:
        n.x = cp_tmp.x + cp_tmp.x + ap[6] ;
        n.y = cp_tmp.y + cp_tmp.y + ap[7] ;
        n.z = cp_tmp.z + cp_tmp.z + ap[8] ;
        break ;
      case 3:
        n.x = (ap[0]*cp_tmp.x*2) + ap[6] ;
        n.y = (ap[1]*cp_tmp.y*2) + ap[7] ;
        n.z = (ap[2]*cp_tmp.z*2) + ap[8] ;
        break ;
      default:
        n.x = ap[0]*cp_tmp.x*2 + ap[3]*cp_tmp.y + ap[5]*cp_tmp.z + ap[6] ;
        n.y = ap[1]*cp_tmp.y*2 + ap[4]*cp_tmp.z + ap[3]*cp_tmp.x + ap[7] ;
        n.z = ap[2]*cp_tmp.z*2 + ap[5]*cp_tmp.x + ap[4]*cp_tmp.y + ap[8] ;
        break ;
    }
    trans_it2(&n,pp->mtx2);
    temp=pow(n.x*n.x + n.y*n.y + n.z*n.z,0.5) ;
    if( pp->sgn < 0 ) temp = -temp ;
    n.x /= temp; n.y /=temp; n.z /= temp ;
    if ((n.x*vec->x + n.y*vec->y + n.z*vec->z)>0)
      {n.x=-n.x; n.y=-n.y; n.z=-n.z; fl=-1;}
    else
      {fl=1;};
/*
#ifdef DEBUG
fprintf(stderr, "Housen=(%f,%f,%f)\n",n.x,n.y,n.z) ;
#endif
*/
    lp_tmp.r = lp.r;
    lp_tmp.g = lp.g;
    lp_tmp.b = lp.b;
    lp.r *= pow(.5, t/hf) ;/* decreace of light power */
    lp.g *= pow(.5, t/hf) ;
    lp.b *= pow(.5, t/hf) ;
    
    if ( pp->shmap == NULL)
    {
      if ( (pp->sh >= colornum) || (pp->sh < 0) )
        err("(trace) `ĂȂJ[io[ł");
      prm = &(color[pp->sh]);
    }
    else
    {
      i = pp->sh + getmap_num(cp.x,cp.y,cp.z, n.x, n.y, n.z, pp->shmap, pmtx);
      if ( (i >= colornum) || (i < 0) )
        err("(trace) `ĂȂJ[io[ł");
      prm = &( color[ i ] );
    }
    
    
    
    d = getmap_n(cp.x,cp.y,cp.z,  n.x,n.y,n.z  ,(*prm).b,(*prm).bmap,(*pp).mtx1,(*pp).mtx2);
    n.x += d.x;
    n.y += d.y;
    n.z += d.z;
    temp = sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
    n.x /= temp;
    n.y /= temp;
    n.z /= temp;
/*    sprintf(msg,"main %lf,%lf,%lf\n",n.x,n.y,n.z);
    mes(msg);*/
    
    
    p_b   = (*prm).pc.b;
    p_r   = (*prm).pc.r;
    p_g   = (*prm).pc.g;
    map_tmp=(MAP *)((*prm).cmap);
    flg = 0;a1=a2=a3=0;
    while ( map_tmp != NULL ) {
      flg += getmap_col(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1, &a2, &a3);
      map_tmp = (MAP *)( (*map_tmp).next );
    }
    if (flg!=0) {
      p_r=a1;
      p_g=a2;
      p_b=a3;
    }
    
    pref  = (*prm).ref;
    map_tmp=(MAP *)((*prm).rmap);
    flg = 0;a1=a2=a3=0;
    while ( map_tmp != NULL ) {
      flg += getmap_col(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1, &a2, &a3 );
      map_tmp = (MAP *)( (*map_tmp).next );
    }
    if (flg!=0) {
      pref.r=a1;
      pref.g=a2;
      pref.b=a3;
    }
    
    
    prefr  = (*prm).refr;
    map_tmp=(MAP *)((*prm).rrmap);
    flg = 0;a1=a2=a3=0;
    while ( map_tmp != NULL ) {
      flg += getmap_col(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1, &a2, &a3 );
      map_tmp = (MAP *)( (*map_tmp).next );
    }
    if (flg!=0) {
      prefr.r=a1;
      prefr.g=a2;
      prefr.b=a3;
    }
    
    
    pn = (*prm).n;
    map_tmp = (MAP *)((*prm).nmap);
    flg = 0;a1=0;
    while ( map_tmp != NULL ) {
      flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
      map_tmp = (MAP *)( (*map_tmp).next );
    }
    if (flg!=0) pn=a1;
    
    
    phalf = (*prm).half;
    map_tmp = (MAP *)((*prm).hmap);
    flg=0;a1=0;
    while ( map_tmp != NULL ) {
      flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
      map_tmp = (MAP *)( (*map_tmp).next );
    }
    if (flg!=0) phalf=a1;
    
    
    
/*
fprintf(stderr,"n=(%f,%f,%f) p=(%f,%f,%f) \n",n.x,n.y,n.z,cp.x,cp.y,cp.z )
 ;
*/
    cs = -(vec->x * n.x + vec->y * n.y + vec->z * n.z);
    if ( (cs*fl < 0) && (prefr.r!=0.0) && (prefr.g!=0.0) && (prefr.b!=0.0) ) 
    {
      nn=1/pn;
      hf1=phalf;
      hf2=half;
      mistcol2=sky;
    }
    else 
    { 
      nn=pn;
      hf1=half;
      hf2=phalf;
      mistcol2.r=mistcol2.g=mistcol2.b=0;
    };
    
    
    
    for( i = 0 ; i < elnum ; i++ ) 
    {                                        /* eternal light */
      ep = &(el[i]) ;
#ifdef DEBUG
fprintf( stderr, "t--Shading on el #%d\n", i ) ;
#endif
      l = &(ep->elt) ;
      k1 = (n.x*l->x + n.y*l->y + n.z*l->z) ;
      
      if( k1 < 0 )
        continue ;/* not lighted */
      if( maxtn != 0 ) {/* check shadow  */
        if (shadow_el( &cp, l, n, hf1, &sw )==0){/* shadowed */
          continue ;
        }
      } 
      tmp = 1.0;
      shading(p_r,p_g,p_b,  pp,cp,n,cp_tmp,l,pref,sw,tmp,k1,prm,pmtx,vec,col,lp,ep->elc);
#ifdef DEBUG
fprintf( stderr,"t--Shading by light RGB=(%f,%f,%f)\n", col->r,col->g,col->b ) ;
#endif
    }
    
    
    
    for( i = 0 ; i < plnum ; i++ ) 
    {                                        /* point light */
      ptp = &(pl[i]) ;
#ifdef DEBUG
fprintf( stderr, "t--Shading on pl #%d\n", i ) ;
#endif
      l = &vec_tmp ;
      l->x = (ptp->plt).x - cp.x;
      l->y = (ptp->plt).y - cp.y;
      l->z = (ptp->plt).z - cp.z;
      tmp = sqrt( sq(l->x) + sq(l->y) + sq(l->z) );
      l->x /= tmp;
      l->y /= tmp;
      l->z /= tmp;
      
      k1 = (n.x*l->x + n.y*l->y + n.z*l->z) ;
      
      if( k1 < 0 )
        continue ;/* not lighted */
      if( maxtn != 0 ) 
      {                               /* check shadow  */
        if (shadow_pl( &cp, l, n, hf1, &sw, ptp->plt )==0)
        {                              /* shadowed */
          continue ;
        }
      } 
      tmp = pow(.5, tmp/ptp->plk) ;
      shading(p_r,p_g,p_b,  pp,cp,n,cp_tmp,l,pref,sw,tmp,k1,prm,pmtx,vec,col,lp,ptp->plc);
#ifdef DEBUG
fprintf( stderr,"t--Shading by light RGB=(%f,%f,%f)\n", col->r,col->g,col->b ) ;
#endif
    }
    
    
    
    
    for( i = 0 ; i < slnum ; i++ ) 
    {                                             /* spot light */
      stp = &(sl[i]) ;
#ifdef DEBUG
fprintf( stderr, "t--Shading on pl #%d\n", i ) ;
#endif
      l = &vec_tmp ;
      l->x = (stp->slt).x - cp.x;
      l->y = (stp->slt).y - cp.y;
      l->z = (stp->slt).z - cp.z;
      tmp = sqrt( sq(l->x) + sq(l->y) + sq(l->z) );
      l->x /= tmp;
      l->y /= tmp;
      l->z /= tmp;
      
      k1 = (n.x*l->x + n.y*l->y + n.z*l->z) ;
      
      if( k1 < 0 )
        continue ;/* not lighted */
      if( maxtn != 0 ) 
      {                                      /* check shadow  */
        if (shadow_pl( &cp, l, n, hf1, &sw, stp->slt )==0)
        {                                     /* shadowed */
          continue ;
        }
      } 
      
      tmp = pow(.5, tmp/stp->slk) ;
      tmp *= pow( cos( acos( -(l->x)*((stp->sld).x) -(l->y)*((stp->sld).y) -(l->z)*((stp->sld).z) )/2 ),stp->sls) ;
      
      shading(p_r,p_g,p_b,  pp,cp,n,cp_tmp,l,pref,sw,tmp,k1,prm,pmtx,vec,col,lp,stp->slc);
      
      
      
      
#ifdef DEBUG
fprintf( stderr,"t--Shading by light RGB=(%f,%f,%f)\n", col->r,col->g,col->b ) ;
#endif
    }
    
    
    
    
    
    col->r += p_r * env.r * lp.r ;
    col->g += p_g * env.g * lp.g ;
    col->b += p_b * env.b * lp.b ; /* environmental light */
    if( mist ) {
      col->r += mistcol.r * (lp_tmp.r-lp.r) ;
      col->g += mistcol.g * (lp_tmp.g-lp.g) ;
      col->b += mistcol.b * (lp_tmp.b-lp.b) ;/* mist */
    }
#ifdef DEBUG
fprintf( stderr,"t-- env shading RGB=(%f,%f,%f)\n",col->r,col->g,col->b )
;
#endif
    ++trnum ;
    if( ( 
          (pref.r == 0) && (pref.g == 0) && (pref.b == 0) && 
          (prefr.r == 0) && (prefr.g == 0) && (prefr.b == 0) 
        ) || (trnum >= maxtn)) /* check refrection */
      return ;
/*
    lp.r *= pref.r;
    lp.g *= pref.g;
    lp.b *= pref.b;  */
    
    if( lp.r > mintv || lp.g > mintv || lp.b > mintv )
    {
      tmp = ( vec->x*n.x + vec->y*n.y + vec->z*n.z ) * 2 ;
      lt.x = vec->x - tmp * n.x ;
      lt.y = vec->y - tmp * n.y ;
      lt.z = vec->z - tmp * n.z ;/* new eye point */
      
      temp=pow((lt.x)*(lt.x) + (lt.y)*(lt.y) + (lt.z)*(lt.z), 0.5 ) ;
      lt.x /= temp;lt.y /=temp; lt.z /= temp ;
#ifdef DEBUG
fprintf( stderr,"****** refrection *******\n" ) ;
fprintf( stderr,"new eye=(%f,%f,%f),new ray=(%f,%f,%f)\n",
cp.x,cp.y,cp.z,lt.x,lt.y,lt.z ) ;
#endif
      
      
      if ( prefr.r==0.0 && prefr.g==0.0 && prefr.b==0.0 )
      { 
        lp.r *= pref.r;
        lp.g *= pref.g;
        lp.b *= pref.b;
        trace( &cp, &lt, col, lp, hf1, trnum, mistcol2 );
      }
      else
      {
        if ( prefr.r==1 && prefr.g==1 && prefr.b==1 &&
             pref.r==0 && pref.g==0 && pref.b==0 &&
             p_r ==0 && p_g==0 && p_b==0 && pn==1 )
        {
          trace ( &cp, vec, col, lp, hf2, trnum, mistcol2);
        }
        else
        {
          
          if ( (ns = nn*nn-1+cs*cs) > 0 )
          {
            ns = sqrt(ns);
            r=( (cs-ns)/(cs+ns) );r=r*r;
            
#ifdef DEBUG
fprintf(stderr,"cs, r = %f , %f\n",cs,r);
#endif
            lp_tmp2.r = lp.r * r * pref.r;
            lp_tmp2.g = lp.g * r * pref.g;
            lp_tmp2.b = lp.b * r * pref.b;
            
            trace ( &cp, &lt ,col, lp_tmp2, hf1, trnum, mistcol2 ); 
            
            lt.x = (vec->x - ( ns - cs ) * n.x)/nn;
            lt.y = (vec->y - ( ns - cs ) * n.y)/nn;
            lt.z = (vec->z - ( ns - cs ) * n.z)/nn;
            
/*
            cp.x = cp.x + lt.x * eps;
            cp.y = cp.y + lt.y * eps;
            cp.z = cp.z + lt.z * eps;
*/          
            lp_tmp2.r = lp.r * (1.0-r) * prefr.r;
            lp_tmp2.g = lp.g * (1.0-r) * prefr.g;
            lp_tmp2.b = lp.b * (1.0-r) * prefr.b;
            trace ( &cp, &lt, col, lp_tmp2, hf2, trnum, mistcol2);
          }
          else 
          {
            lp.r *= pref.r;
            lp.g *= pref.g;
            lp.b *= pref.b;
            trace ( &cp, &lt, col, lp, hf1, trnum, mistcol2 );
          };
            
        };
      }
    }
  }
  else
  {                             /* not cross */
#ifdef DEBUG
fprintf( stderr, "t--Ray don't cross\n" ) ;
#endif
    for( i = 0 ; i < elnum ; i++ )
    {                                             /* eternal light */
      ep = &(el[i]) ;
      if( ep->els == 1 )continue ;/* light size = 0 */
      tmp = ep->elt.x*vec->x+ep->elt.y*vec->y+ep->elt.z*vec->z - ep->els ;
      
      if( tmp > 0 )
      {
        tmp = pow((tmp/(1-ep->els)),ep->elk) ;
        col->r += lp.r * tmp * ep->elc.r ;
        col->g += lp.g * tmp * ep->elc.g ;
        col->b += lp.b * tmp * ep->elc.b ;/* add light color */
#ifdef DEBUG
fprintf( stderr,"i--Ray into light #%d\n", i ) ;
#endif
      }
    }
    col->r += lp.r * sky.r ;
    col->g += lp.g * sky.g ;
    col->b += lp.b * sky.b ;/* sky color */
  }
}

int shadow_el( FV *eye, FV *vec, FV n, float hf, FRGB *sw )
{
FV cp,lt ;
float t,phalf,a1,a2,a3,half ;
FRGB pcol,pw ;
int tprim ;
PRIM *pp ;
int flg;
MAP *map_tmp;
SHADE *prm;
MATRIX pmtx;

  pw.r = pw.g = pw.b = 1.0;
  half = hf;
  
  cp.x = eye->x;
  cp.y = eye->y;
  cp.z = eye->z;
  
  lt.x = vec->x;
  lt.y = vec->y;
  lt.z = vec->z;
  
  while(1){
    if( (tprim = cross( &cp, &lt, &t, 0 )) >= 0 ) {    
      pp = &(pr[tprim]) ;
      
      if ( pp->shmap == NULL)
      {
        prm = &(color[pp->sh]);
      }
      else
      {
        prm = &( color[ pp->sh + getmap_num(cp.x,cp.y,cp.z, n.x, n.y, n.z, pp->shmap, pmtx) ] );
      }
      
      mtx_copy(pmtx,pp->mtx1) ;
      phalf = (*prm).half;
      map_tmp = (MAP *)((*prm).hmap);
      flg=0;a1=0;
      while ( map_tmp != NULL ) {
        flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
        map_tmp = (MAP *)( (*map_tmp).next );
      }
      if (flg!=0) phalf=a1;
      
      pcol = (*prm).refr;
      map_tmp = (MAP *)((*prm).rrmap);
      flg=0;a1=a2=a3=0;
      while ( map_tmp != NULL ) {
        flg += getmap_col(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1, &a2, &a3 );
        map_tmp = (MAP *)( (*map_tmp).next );
      }
      if (flg!=0) {
        pcol.r=a1;
        pcol.g=a2;
        pcol.b=a3;
      }
      
      if (phalf == 0){
        return(0);}
      else{
        pw.r *= ( pow(.5, t/half)*pcol.r )  ;
        pw.g *= ( pow(.5, t/half)*pcol.g )  ;
        pw.b *= ( pow(.5, t/half)*pcol.b )  ;
        cp.x += lt.x * t;
        cp.y += lt.y * t;
        cp.z += lt.z * t;
        half = phalf;
      };
    }
    else break;
  };
  
  *sw = pw;
  return(1);
}



int shadow_pl( FV *eye, FV *vec, FV n, float hf, FRGB *sw, FV pnt )
{
FV cp,lt ;
float t,phalf,t_tmp,a1,a2,a3,half ;
FRGB pcol,pw ;
int tprim ;
PRIM *pp ;
int flg ;
MAP *map_tmp ;
SHADE *prm ;
MATRIX pmtx ;

  pw.r = pw.g = pw.b = 1.0;
  half = hf;
  
  cp.x = eye->x;
  cp.y = eye->y;
  cp.z = eye->z;
  
  lt.x = vec->x;
  lt.y = vec->y;
  lt.z = vec->z;
  
  while(1){
    t_tmp = sq(cp.x-pnt.x) + sq(cp.y-pnt.y) + sq(cp.z-pnt.z) ;
    if (t_tmp == 0.0) break ;
    t_tmp = sqrt(t_tmp) ;
    tprim = cross( &cp, &lt, &t, 0 ) ;
    if ( tprim >= 0 ) {    
      pp = &(pr[tprim]) ;
      
      if ( pp->shmap == NULL)
      {
        prm = &(color[pp->sh]);
      }
      else
      {
        prm = &( color[ pp->sh + getmap_num(cp.x,cp.y,cp.z, n.x, n.y, n.z, pp->shmap, pmtx) ] );
      }
      
      mtx_copy(pmtx,pp->mtx1) ;
      
      phalf = (*prm).half;
      map_tmp = (MAP *)((*prm).hmap);
      flg=0;a1=0;
      while ( map_tmp != NULL ) {
        getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
        map_tmp = (MAP *)( (*map_tmp).next );
      }
      if (flg!=0) phalf=a1;
      
      pcol = (*prm).refr;
      map_tmp = (MAP *)((*prm).rrmap);
      flg=0;a1=a2=a3=0;
      while ( map_tmp != NULL ) {
        flg += getmap_col(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1, &a2, &a3 );
        map_tmp = (MAP *)( (*map_tmp).next );
      }
      if (flg!=0) {
        pcol.r=a1;
        pcol.g=a2;
        pcol.b=a3;
      }
      
      
      
      
      
      if (phalf == 0){
        return(0);}
      else{
        if ( t < t_tmp ) {
          pw.r *= ( pow(.5, t/half)*pcol.r )  ;
          pw.g *= ( pow(.5, t/half)*pcol.g )  ;
          pw.b *= ( pow(.5, t/half)*pcol.b )  ;
          cp.x += lt.x * t;
          cp.y += lt.y * t;
          cp.z += lt.z * t;
          half = phalf;
        } else {
          pw.r *= ( pow(.5, t/half)*pcol.r )  ;
          pw.g *= ( pow(.5, t/half)*pcol.g )  ;
          pw.b *= ( pow(.5, t/half)*pcol.b )  ;
          break;
        };
      };
    }
    else break;
  };
    
  *sw = pw;
  return(1);
}



void shading(float p_r,float p_g,float p_b,PRIM *pp,FV cp,FV n,FV cp_tmp,FV *l,FRGB pref,FRGB sw,float tmp,float k1,SHADE *prm,MATRIX pmtx,FV *vec, FRGB *col, FRGB lp, FRGB lc)
{
float a1,a2,a3 ;
float k2 ;
float x,y,z ,phigh,pk;
FV v,p,p1,p2,p3 ;
int flg ;
float bn,bf,g1,g2  ,ba,bb,bc;
MAP *map_tmp ;


      switch ( (*prm).styp ) {
        case 0:
          if( (l->x*n.x+l->y*n.y+l->z*n.z) < 0   )
            return ;
          
          phigh   = ( *( (SPECK1 *)((*prm).spara) ) ).high;
          map_tmp = (MAP *)(( *( (SPECK1 *)((*prm).spara) ) ).hmap);
          flg = 0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) phigh=a1;
          
          pk      = ( *( (SPECK1 *)((*prm).spara) ) ).k;
          map_tmp = (MAP *)(( *( (SPECK1 *)((*prm).spara) ) ).kmap);
          flg=0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) pk=a1;
          
          x = l->x - vec->x; y = l->y - vec->y; z = l->z - vec->z ;
          if( (k2 = (x*n.x+y*n.y+z*n.z)) < 0   )
            return ;
          k2 = phigh * pow( k2 / sqrt(x*x+y*y+z*z),pk);
          col->r += lc.r * sw.r * tmp * (p_r * lp.r * k1 + k2*lp.r ) ;
          col->g += lc.g * sw.g * tmp * (p_g * lp.g * k1 + k2*lp.g ) ;
          col->b += lc.b * sw.b * tmp * (p_b * lp.b * k1 + k2*lp.b ) ;
          break;
          
          
        case 1:
          if( (l->x*n.x+l->y*n.y+l->z*n.z) < 0   )
            return ;
          
          pref    = ( *( (SPECK2 *)((*prm).spara) ) ).ref;
          map_tmp = (MAP *)(( *( (SPECK2 *)((*prm).spara) ) ).rmap);
          flg=0;a1=a2=a3=0;
          while ( map_tmp != NULL ) {
            flg += getmap_col(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1, &a2, &a3 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) {
            pref.r=a1;
            pref.g=a2;
            pref.b=a3;
          }
          
          bn      = ( *( (SPECK2 *)((*prm).spara) ) ).n;
          map_tmp = (MAP *)(( *( (SPECK2 *)((*prm).spara) ) ).nmap);
          flg=0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) bn=a1;
          
          bf      = ( *( (SPECK2 *)((*prm).spara) ) ).f;
          map_tmp = (MAP *)(( *( (SPECK2 *)((*prm).spara) ) ).fmap);
          flg=0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) bf=a1;
          
          x = l->x - vec->x; y = l->y - vec->y; z = l->z - vec->z ;
          if( (x*n.x+y*n.y+z*n.z) < 0   )
            return ;
          k2 = sqrt(x*x+y*y+z*z);
          x /= k2;
          y /= k2;
          z /= k2;
          g1 = -2 * (n.x*x+n.y*y+n.z*z) * (n.x*l->x+n.y*l->y+n.z*l->z) / (vec->x*x+vec->y*y+vec->z*z);
          g2 = 2 * (n.x*x+n.y*y+n.z*z) * (n.x*vec->x+n.y*vec->y+n.z*vec->z) / (vec->x*x+vec->y*y+vec->z*z);
          if (g1>g2) g1=g2;
          if (g1>1.0) g1=1.0;
          k2 = acos(n.x*x+n.y*y+n.z*z)*bn;
          k2 = bf*g1*exp(-k2*k2)/fabs(n.x*vec->x+n.y*vec->y+n.z*vec->z);
          col->r += lc.r * sw.r * tmp * (p_r * lp.r * k1 + pref.r*k2*lp.r ) ;
          col->g += lc.g * sw.g * tmp * (p_g * lp.g * k1 + pref.g*k2*lp.g ) ;
          col->b += lc.b * sw.b * tmp * (p_b * lp.b * k1 + pref.b*k2*lp.b ) ;
          break;
          
        case 2:
          if( (l->x*n.x+l->y*n.y+l->z*n.z) < 0   )
            return ;
          p2.x   = ( *( (SPECK3 *)((*prm).spara) ) ).px;
          p2.y   = ( *( (SPECK3 *)((*prm).spara) ) ).py;
          p2.z   = ( *( (SPECK3 *)((*prm).spara) ) ).pz;
          v.x   = ( *( (SPECK3 *)((*prm).spara) ) ).vx;
          v.y   = ( *( (SPECK3 *)((*prm).spara) ) ).vy;
          v.z   = ( *( (SPECK3 *)((*prm).spara) ) ).vz;
          
          
          
          pref    = ( *( (SPECK3 *)((*prm).spara) ) ).ref;
          map_tmp = (MAP *)(( *( (SPECK3 *)((*prm).spara) ) ).rmap);
          flg=0;a1=a2=a3=0;
          while ( map_tmp != NULL ) {
            flg += getmap_col(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1, &a2, &a3 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) {
            pref.r=a1;
            pref.g=a2;
            pref.b=a3;
          }
          
          ba   = ( *( (SPECK3 *)((*prm).spara) ) ).a;
          map_tmp = (MAP *)(( *( (SPECK3 *)((*prm).spara) ) ).amap);
          flg = 0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) ba=a1;
          
          
          bb   = ( *( (SPECK3 *)((*prm).spara) ) ).b;
          map_tmp = (MAP *)(( *( (SPECK3 *)((*prm).spara) ) ).bmap);
          flg = 0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) bb=a1;
          
          
          bc   = ( *( (SPECK3 *)((*prm).spara) ) ).c;
          map_tmp = (MAP *)(( *( (SPECK3 *)((*prm).spara) ) ).cmap);
          flg = 0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) bc=a1;
          
          
          
          
          p.x = l->x - vec->x; p.y = l->y - vec->y; p.z = l->z - vec->z ;
          trans_it2(&p,pp->mtx1);
          k2 = sqrt(p.x*p.x + p.y*p.y + p.z*p.z);
          p.x /= k2;
          p.y /= k2;
          p.z /= k2;
          
          p1.x = n.x; p1.y = n.y; p1.z = n.z ;
          trans_it2(&p1,pp->mtx1);
          k2 = sqrt(p1.x*p1.x + p1.y*p1.y + p1.z*p1.z);
          p1.x /= k2;
          p1.y /= k2;
          p1.z /= k2;
          
          
          p2.x = cp_tmp.x - p2.x;
          p2.y = cp_tmp.y - p2.y;
          p2.z = cp_tmp.z - p2.z;
          v = ptr_cross(p1,p2);
          
          p2 = ptr_cross(p1,v);
          p3 = ptr_cross(p1,p2);
          k2 = sqrt(p2.x*p2.x + p2.y*p2.y + p2.z*p2.z);
          p2.x /= k2;
          p2.y /= k2;
          p2.z /= k2;
          k2 = sqrt(p3.x*p3.x + p3.y*p3.y + p3.z*p3.z);
          p3.x /= k2;
          p3.y /= k2;
          p3.z /= k2;
          
          
          
          a1 = p.x*p2.x + p.y*p2.y + p.z*p2.z ;
          a2 = p.x*p3.x + p.y*p3.y + p.z*p3.z ;
          a3 = p.x*p1.x + p.y*p1.y + p.z*p1.z ;
          
          k2 = 2*a3*bc/((a1/ba)*(a1/ba)+(a2/bb)*(a2/bb)+(a3/bc)*(a3/bc));
          
          col->r += lc.r * sw.r * tmp * (p_r * lp.r * k1 + pref.r*k2*lp.r ) ;
          col->g += lc.g * sw.g * tmp * (p_g * lp.g * k1 + pref.g*k2*lp.g ) ;
          col->b += lc.b * sw.b * tmp * (p_b * lp.b * k1 + pref.b*k2*lp.b ) ;
          break;
          
          
        case 3:
          if( (l->x*n.x+l->y*n.y+l->z*n.z) < 0   )
            return ;
          v.x   = ( *( (SPECK4 *)((*prm).spara) ) ).vx;
          v.y   = ( *( (SPECK4 *)((*prm).spara) ) ).vy;
          v.z   = ( *( (SPECK4 *)((*prm).spara) ) ).vz;
          
          
          pref    = ( *( (SPECK4 *)((*prm).spara) ) ).ref;
          map_tmp = (MAP *)(( *( (SPECK4 *)((*prm).spara) ) ).rmap);
          flg=0;a1=a2=a3=0;
          while ( map_tmp != NULL ) {
            flg += getmap_col(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1, &a2, &a3 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) {
            pref.r=a1;
            pref.g=a2;
            pref.b=a3;
          }
          
          
          ba   = ( *( (SPECK4 *)((*prm).spara) ) ).a;
          map_tmp = (MAP *)(( *( (SPECK4 *)((*prm).spara) ) ).amap);
          flg = 0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) ba=a1;
          
          
          bb   = ( *( (SPECK4 *)((*prm).spara) ) ).b;
          map_tmp = (MAP *)(( *( (SPECK4 *)((*prm).spara) ) ).bmap);
          flg = 0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) bb=a1;
          
          
          bc   = ( *( (SPECK4 *)((*prm).spara) ) ).c;
          map_tmp = (MAP *)(( *( (SPECK4 *)((*prm).spara) ) ).cmap);
          flg = 0;a1=0;
          while ( map_tmp != NULL ) {
            flg += getmap_mono(cp.x, cp.y, cp.z, n.x, n.y, n.z, map_tmp, pmtx, &a1 );
            map_tmp = (MAP *)( (*map_tmp).next );
          }
          if (flg!=0) bc=a1;
          
          
          
          
          p.x = l->x - vec->x; p.y = l->y - vec->y; p.z = l->z - vec->z ;
          trans_it2(&p,pp->mtx1);
          k2 = sqrt(p.x*p.x + p.y*p.y + p.z*p.z);
          p.x /= k2;
          p.y /= k2;
          p.z /= k2;
          
          p1.x = n.x; p1.y = n.y; p1.z = n.z ;
          trans_it2(&p1,pp->mtx1);
          k2 = sqrt(p1.x*p1.x + p1.y*p1.y + p1.z*p1.z);
          p1.x /= k2;
          p1.y /= k2;
          p1.z /= k2;
          
          p2 = ptr_cross(p1,v);
          p3 = ptr_cross(p1,p2);
          
          k2 = sqrt(p2.x*p2.x + p2.y*p2.y + p2.z*p2.z);
          p2.x /= k2;
          p2.y /= k2;
          p2.z /= k2;
          k2 = sqrt(p3.x*p3.x + p3.y*p3.y + p3.z*p3.z);
          p3.x /= k2;
          p3.y /= k2;
          p3.z /= k2;
          
          a1 = p.x*p2.x + p.y*p2.y + p.z*p2.z ;
          a2 = p.x*p3.x + p.y*p3.y + p.z*p3.z ;
          a3 = p.x*p1.x + p.y*p1.y + p.z*p1.z ;
          
          k2 = 2*a3*bc/((a1/ba)*(a1/ba)+(a2/bb)*(a2/bb)+(a3/bc)*(a3/bc));
          
          col->r += lc.r * sw.r * tmp * (p_r * lp.r * k1 + pref.r*k2*lp.r ) ;
          col->g += lc.g * sw.g * tmp * (p_g * lp.g * k1 + pref.g*k2*lp.g ) ;
          col->b += lc.b * sw.b * tmp * (p_b * lp.b * k1 + pref.b*k2*lp.b ) ;
          break;
          
      }

}


